
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#ifdef __OpenBSD__
# include <net/if.h>
# include <net/if_arp.h>
#endif  /* __OpenBSD__ */

#ifdef __linux__
# include <time.h>
# include <netinet/ether.h>
#else   /* __linux__ */
# include <netinet/if_ether.h>
#endif  /* __linux__ */

#include <libnet.h>

int main(int argc, char *argv[]) {
    libnet_t *ln;
    struct ether_addr *ha = NULL;
    char ebuf[LIBNET_ERRBUF_SIZE] = "\0";

    if (!(ln = libnet_init(LIBNET_LINK_ADV, argv[1], ebuf))) {
        fprintf(stderr, "%s", ebuf);
        exit(EXIT_FAILURE);
    }

    if ((ha = (struct ether_addr *) libnet_get_hwaddr(ln)) == NULL) {
        fprintf(stderr, "%s", libnet_geterror(ln));
        exit(EXIT_FAILURE);
    }

    printf("hwaddr: %s\n", ether_ntoa(ha));

    libnet_destroy(ln);

    return 0;
}
